#ifndef _fbsd_compat_h
#define _fbsd_compat_h

/* needed for node reference in videodev2.h */

#include <sys/types.h>
#include <sys/param.h>
#include <sys/queue.h>
#include <sys/systm.h>
#include <sys/kernel.h>
#include <sys/syslog.h>
#include <sys/conf.h>
#include <sys/bus.h>
#include <machine/bus.h>
#include <sys/rman.h>
#include <machine/resource.h>
#include <vm/vm.h>
#include <vm/vm_kern.h>
#include <vm/pmap.h>
#include <sys/mman.h>
#include <sys/lock.h>
#include <sys/sem.h>
#include <sys/param.h>
#include <sys/kernel.h>
#include <sys/systm.h>
#include <sys/module.h>
#include <sys/bus.h>
#include <sys/types.h>
#include <sys/taskqueue.h>
#include <sys/file.h>
#include <sys/poll.h>
#include <sys/malloc.h>
#include <sys/signal.h>
#include <sys/signalvar.h>
#include <sys/ioccom.h>
#include <sys/proc.h>
#include <sys/kthread.h>


#ifndef _FBSD6_
#include <sys/mount.h>
#include <ufs/ufs/dinode.h> 
#endif
#include <ufs/ffs/fs.h>
#include <ufs/ufs/quota.h>
#include <ufs/ufs/inode.h>

#undef i_flags /* this too! */





/* these were defined in BKTR_IOCTL.h */
#undef AUDIO_EXTERN
#undef AUDIO_INTERN

/* missing types ? */
#if __FreeBSD_version < 500000
	#include <sys/inttypes.h>
#else
	#include <inttypes.h>
#endif

#define u16 uint16_t
#define u32 uint32_t
#define u8  uint8_t
#define __u32 uint32_t
#define __u8 uint8_t
#define __u16 uint16_t
#define __s32 int32_t
#define __u64	uint32_t
#define s8	int8_t
#define s16	int16_t
#define s32	int32_t



/* macros too compile linux-modules easily */

#define MODULE_PARM_DESC(x,y)
#define MODULE_PARM(x,y)
#define MODULE_AUTHOR(x)
#define MODULE_LICENSE(x)
#define MODULE_DESCRIPTION(x)
#define MODULE_SUPPORTED_DEVICE(x)
#define KERN_ERR "<3>"
#define KERN_INFO "<2>"
#define printk(x, args...) log(LOG_INFO,x, ##args)
#define I2C_CLIENT_INSMOD 
#define devfs_handle_t int
#define __user 
#define THIS_MODULE "tasteslike..."
#define I2C_DF_NOTIFY 3
#define I2C_DRIVERID_CX25840 0x88
#define I2C_FUNC_I2C 3
#define CAP_SYS_ADMIN 3
#define module_param(x,y,z)
#define capable(x)	3
#define i2c_check_functionality(x,y) 3
#define i2c_driver dummy
#define I2C_CLIENT_END          0xfffe
#define I2C_CLIENT_ALLOW_USE            0x01  


#include <machine/clock.h>
#define msleep_interruptible(x) DELAY(x)


/* additional dummys for videodev2.h */

struct dummy { int dummy_int; } ;

#define class_device dummy
#define class_device_attribute dummy
#define inline 

/* missing V4L2 constants ? */
#define IVTV_SLICED_TYPE_TELETEXT_B     (1)
#define IVTV_SLICED_TYPE_CAPTION_525    (4)
#define IVTV_SLICED_TYPE_WSS_625        (5)
#define IVTV_SLICED_TYPE_VPS            (7)

/* I2C compatibility layer ( see .c ) */



#define i2c_get_clientdata(x)  &(local_info[device_get_unit(x)])
#define i2c_set_clientdata(x,y)

int i2c_master_send(device_t client, u8 *buffer, int len);
int i2c_master_recv(device_t client, u8 *buffer, int len);
void cx25840_i2c_set_delay(device_t client, int delay);

extern u8 i2c_cl[4]; /* ugly */
extern void *i2c_cd; /* ugly */

/* firmware load is implemented here ( ugly ) */

/* #include "cx25840.h" */

int request_firmware(void **fw, char *file, int dummy);
int release_firmware(void *fw);

#define KERNEL_VERSION(x,y,z) 1000
#define LINUX_VERSION_CODE 1001
#define GFP_KERNEL 1

#include "videodev2.h"
#include "videodev.h"
#include "video_decoder.h"

#endif
