#include "fbsd-compat.h"

#include "v4l2_ioctl_hook.h"

int v4l2_ioctl_hook(struct cxm_softc *sc, unsigned long cmd, caddr_t arg)
{
/* 	int		brightness;
	int		chroma_saturation;
	int		contrast;
	int		fps;
	int		hue;
	int		result;
	int		status;
	int		unit;
	unsigned int	i;
	unsigned int	sig;
	unsigned long	freq; */
/*
	enum cxm_source	source;
	struct bktr_capture_area *cap;
	struct bktr_remote *remote;
	intrmask_t	s; */
unsigned int i;

	switch(cmd)
	{

         /* Video 4 Linux like ioctl's... */
	case VIDIOC_G_CTRL:
		break;

	case 0:
         case VIDIOC_QUERYCAP:
         {
                 struct v4l2_capability *vcap = (struct v4l2_capability *)arg;
                 memset (vcap, 0, sizeof (*vcap));
 
                 /* driver name */
                 strcpy(vcap->driver,"CXM");
 
                 /* card type */
                 strcpy(vcap->card,"Hauppauge PVR-250");
 
                 /* bus info... */
                 strcpy(vcap->bus_info, "PCI:0");
 
                 /* version */
                 vcap->version = 0;
 
                 /* capabilities */
                 vcap->capabilities = (V4L2_CAP_VIDEO_CAPTURE|V4L2_CAP_TUNER|
                                        V4L2_CAP_AUDIO|V4L2_CAP_READWRITE);
 
                 break;
         }
         case VIDIOC_G_FMT:
         {
                 struct v4l2_format *vfmt = (struct v4l2_format *)arg;
                 memset (vfmt, 0, sizeof (*vfmt));
 
                 vfmt->type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
                 vfmt->fmt.pix.field = V4L2_FIELD_INTERLACED;
                 vfmt->fmt.pix.sizeimage = (128*1024);
                 vfmt->fmt.pix.width = sc->profile->width;
                 vfmt->fmt.pix.height = sc->profile->height;
 
                 break;
         }
         case VIDIOC_S_FMT:
         {
                 struct v4l2_format *vfmt = (struct v4l2_format *)arg;
 
		break;

                 if (sc->encoding)
                         return EBUSY;
 
                 if ((vfmt->fmt.pix.width % CXM_MACROBLOCK_WIDTH)
                     || (vfmt->fmt.pix.height % CXM_MACROBLOCK_HEIGHT))
                         return EINVAL;
 
                 /*
                  * Setting the width and height has the side effect of
                  * chosing between the VCD, SVCD, and DVD profiles.
                  */
 
                 for (i = 0; i < NUM_ELEMENTS(codec_profiles); i++)
                         if (codec_profiles[i]->width == vfmt->fmt.pix.width
                             && codec_profiles[i]->height == vfmt->fmt.pix.height)
                                 break;
 
                 if (i >= NUM_ELEMENTS(codec_profiles))
                 {
                         /* need more codec profiles... just ignore for now */
                         break;
                         /*  return EINVAL; */
                 } else {
                         sc->profile = codec_profiles[i];
                 }
                 break;
         }
         case VIDIOC_S_STD:
                 /* should try to set this to something else than NTSC */
                 break;
         case VIDIOC_ENUMINPUT:
         {
                 struct v4l2_input *vin = (struct v4l2_input *)arg;
 
                 if ((vin->index < 0) || (vin->index >=  NUM_INPUTS))
                         return(-EINVAL);
 
                 memcpy(vin, &tmk_inputs[vin->index], sizeof(struct v4l2_input));
                 vin->std = V4L2_STD_PAL;
                 vin->status = 0;
                 
		break;
         }
         case VIDIOC_S_CTRL:
         {
#ifdef _nuniet_ 
  struct v4l2_control *vctrl = (struct v4l2_control *)arg;

                 switch (vctrl->id) {
                 case V4L2_CID_BRIGHTNESS:
                 {
 
                         if (vctrl->value < 0 || vctrl->value > 255) {
                                 return(-EINVAL);
                         }
 
                         if (cxm_saa7115_set_brightness(sc, vctrl->value) < 0)
                                 return ENXIO;
 
                         break;
                 }
                 case V4L2_CID_HUE:
                 {
                         if (vctrl->value < -128 || vctrl->value > 127) {
                                 return(-EINVAL);
                         }
 
                         if (cxm_saa7115_set_hue(sc, vctrl->value) < 0)
                                 return ENXIO;
 
                         break;
                 }
                 case V4L2_CID_SATURATION:
                 {
                         if (vctrl->value < 0 || vctrl->value > 127) {
                                 return(-EINVAL);
                         }
 
                         if (cxm_saa7115_set_chroma_saturation(sc,
                                 vctrl->value) < 0)
                                 return ENXIO;
 
                         break;
                 }
                 case V4L2_CID_CONTRAST:
                 {
                         if (vctrl->value < 0 || vctrl->value > 127) {
                                 return(-EINVAL);
                         }
 
                         if (cxm_saa7115_set_contrast(sc, vctrl->value) < 0)
                                 return ENXIO;
 
                         break;
                 }
                 case V4L2_CID_AUDIO_VOLUME:
                 {
                         if (vctrl->value > 65535 || vctrl->value < 0) {
                                 return(-EINVAL);
                         }
 
                         break;
                 }
                 case V4L2_CID_AUDIO_MUTE:
                 {
                         if (vctrl->value) {
                                 if (cxm_msp_mute(sc) < 0) return ENXIO;
                         } else {
                                 if (cxm_msp_unmute(sc) < 0) return ENXIO;
                         }
 
                         break;
                 }
                 default:
                         return(-EINVAL);
                 }
#endif
 
 
                 break;
         }
         case VIDIOC_QUERYCTRL:
         {
                 struct v4l2_queryctrl *qctrl = (struct v4l2_queryctrl *)arg;
 
                 qctrl->flags = V4L2_CTRL_FLAG_DISABLED;
 
                 switch (qctrl->id) {
                 case V4L2_CID_BRIGHTNESS:
                 {
                         qctrl->type = V4L2_CTRL_TYPE_INTEGER;
                         strncpy(qctrl->name, "Brightness", 32);
                         qctrl->minimum = 0;
                         qctrl->maximum = 255;
                         qctrl->step = 0;
                         qctrl->default_value = 128;
                         qctrl->flags = 0;
                         qctrl->reserved[0] = 0;
                         qctrl->reserved[1] = 0;
                         break;
                 }
                 case V4L2_CID_HUE:
                 {
                         qctrl->type = V4L2_CTRL_TYPE_INTEGER;
                         strncpy(qctrl->name, "Hue", 32);
                         qctrl->minimum = -128;
                         qctrl->maximum = 127;
                         qctrl->step = 0;
                         qctrl->default_value = 0;
                         qctrl->flags = 0;
                         qctrl->reserved[0] = 0;
                         qctrl->reserved[1] = 0;
                         break;
                 }
                 case V4L2_CID_SATURATION:
                 {
                         qctrl->type = V4L2_CTRL_TYPE_INTEGER;
                         strncpy(qctrl->name, "Saturation", 32);
                         qctrl->minimum = 0;
                         qctrl->maximum = 127;
                         qctrl->step = 0;
                         qctrl->default_value = 64;
                         qctrl->flags = 0;
                         qctrl->reserved[0] = 0;
                         qctrl->reserved[1] = 0;
                         break;
                 }
                 case V4L2_CID_CONTRAST:
                 {
                         qctrl->type = V4L2_CTRL_TYPE_INTEGER;
                         strncpy(qctrl->name, "Contrast", 32);
                         qctrl->minimum = 0;
                         qctrl->maximum = 127;
                         qctrl->step = 0;
                         qctrl->default_value = 64;
                         qctrl->flags = 0;
                         qctrl->reserved[0] = 0;
                         qctrl->reserved[1] = 0;
                         break;
                 }
                 case V4L2_CID_AUDIO_VOLUME:
                 {
                         qctrl->type = V4L2_CTRL_TYPE_INTEGER;
                         strncpy(qctrl->name, "Volume", 32);
                         qctrl->minimum = 0;
                         qctrl->maximum = 65535;
                         qctrl->step = 0;
                         qctrl->default_value = 65535;
                         qctrl->flags = 0;
                         qctrl->reserved[0] = 0;
                         qctrl->reserved[1] = 0;
                         break;
                 }
                 case V4L2_CID_AUDIO_MUTE:
                 {
                         qctrl->type = V4L2_CTRL_TYPE_INTEGER;
                         strncpy(qctrl->name, "Mute", 32);
                         qctrl->minimum = 0;
                         qctrl->maximum = 1;
                         qctrl->step = 0;
                         qctrl->default_value = 1;
                         qctrl->flags = 0;
                         qctrl->reserved[0] = 0;
                         qctrl->reserved[1] = 0;
                         break;
                 }
                 default:
                 {
                         if (qctrl->id < V4L2_CID_BASE ||
                             qctrl->id > V4L2_CID_LASTP1)
                                 return EINVAL;
                         break;
                 }
                 }  /* switch(qctrl->id) */
 
                 break;
         }
         case VIDIOC_S_INPUT:
         {
                 /* int inp = *(int *)arg; */
 
                 /* FIXME - later */

                 break;
         }
         case VIDIOC_S_FREQUENCY:
         {
                 struct v4l2_frequency *vf=(struct v4l2_frequency *)arg;

 
                 /* Convert from Mhz * 16 to kHz */
                 unsigned long freq = (vf->frequency * 1000) / 16;
                 int result;

                 if (sc->source == cxm_tuner_source)
                         if (cxm_pause_encoder(sc) < 0)
                                 return ENXIO;


tda9887_command(sc->iicbus, cmd, vf);

                 if (cxm_tuner_select_frequency(sc, cxm_tuner_tv_freq_type,
                                                freq) < 0)
                         return ENXIO;


                 /*
                  * Explicitly wait for the tuner lock so we
                  * can indicate if there's a station present.
                  */
                 if (cxm_tuner_wait_for_lock(sc) < 0) {
                         sc->tuner_signal = 0;
                         /* return EINVAL; */
                 }

                 result = cxm_encoder_wait_for_lock(sc);
                 if (result < 0) {
                         return ENXIO;
                 } else if (result == 0) {
                         sc->tuner_signal = 0;
                         /* return EINVAL; */
                 } else {
                         sc->tuner_signal = 65535; /* best possible signal */
                 }
 
                 if (sc->source == cxm_tuner_source)
                         if (cxm_unpause_encoder(sc) < 0)
                                 return ENXIO;

DELAY(10000);
		 cx25840_command(sc->iicbus, VIDIOC_LOG_STATUS,NULL);

                 break;
         }
         case VIDIOC_G_TUNER:
         {
                 struct v4l2_tuner *vt=(struct v4l2_tuner *)arg;
 
                 vt->signal = 100; /*  sc->tuner_signal; */
                 break;
         }
         case IVTV_IOC_G_CODEC:
         {
                 struct ivtv_ioctl_codec *codec=(struct ivtv_ioctl_codec *)arg;
                 const struct cxm_codec_profile *cpp = sc->profile;
 
                 codec->aspect = cpp->aspect;
/*                  codec->audio_bitmask = cpp->audio; */
                 codec->bframes = cpp->gop.bframes;
                 codec->bitrate_mode = cpp->bitrate.mode;
                 codec->bitrate = cpp->bitrate.average;
                 codec->bitrate_peak = cpp->bitrate.peak;
                 codec->dnr_spatial = cpp->dnr.spatial;
                 codec->dnr_temporal = cpp->dnr.temporal;
                 codec->dnr_type = cpp->dnr.type;
                 codec->framerate = cpp->fps == 30 ? 0 : 1;
                 codec->framespergop = cpp->gop.frames;
                 codec->gop_closure = cpp->gop.closure;
                 codec->pulldown = cpp->pulldown;
                 codec->stream_type = cpp->stream_type;
 
                 break;
         }
         case IVTV_IOC_S_CODEC:
         {
                 /* struct ivtv_ioctl_codec *codec=(struct ivtv_ioctl_codec *)arg; */
 
                 /* FIXME - need to figure out how to set this stuff */
                 break;
         }

	default:
		return ENOTTY;

	} /* case cmd */

	return 0;

} /* v4l2_ioctl_hook */

