#ifndef _v4l2_ioctl_hook_h
#define _v4l2_ioctl_hook_h

#include "../../../dev/cxm/cxm.h"

#include "fbsd-compat.h"

#include "cx25840.h"
#include "tda9887.h"
#include "audiochip.h"
#include "tuner.h"

#define NUM_INPUTS 10

 struct ivtv_ioctl_codec {
         uint32_t aspect;
         uint32_t audio_bitmask;  
         uint32_t bframes;
         uint32_t bitrate_mode;
         uint32_t bitrate;
         uint32_t bitrate_peak;
         uint32_t dnr_mode;
         uint32_t dnr_spatial;
         uint32_t dnr_temporal;
         uint32_t dnr_type;
         uint32_t framerate;
         uint32_t framespergop;
         uint32_t gop_closure;
         uint32_t pulldown;
         uint32_t stream_type;
 };

 /*  Values for the 'type' field */
 #define V4L2_INPUT_TYPE_TUNER           1
 #define V4L2_INPUT_TYPE_CAMERA          2
 #define IVTV_IOC_G_CODEC	_IOR  ('V', 73, struct ivtv_ioctl_codec)
 #define IVTV_IOC_S_CODEC	_IOWR ('V', 74, struct ivtv_ioctl_codec)

struct v4l2_input tmk_inputs[NUM_INPUTS] = {
         {
         .index          = 0,
         .name           = "Composite 0",
         .type           = V4L2_INPUT_TYPE_CAMERA,
         .audioset       = 1,
         .tuner          = 0,
         .status         = 0,
         },{
         .index          = 1,
         .name           = "Composite 1",
         .type           = V4L2_INPUT_TYPE_CAMERA,
         .audioset       = 1,
         .tuner          = 0,
         .status         = 0,
         },{
         .index          = 2,
         .name           = "Composite 2",
         .type           = V4L2_INPUT_TYPE_CAMERA,
         .audioset       = 1,
         .tuner          = 0,
         .status         = 0,
         },{
         .index          = 3,
         .name           = "Composite 3",
         .type           = V4L2_INPUT_TYPE_CAMERA,
         .audioset       = 1,
         .tuner          = 0,
         .status         = 0,
         },{
         .index          = 4,
         .name           = "Tuner 0",
         .type           = V4L2_INPUT_TYPE_TUNER,
         .audioset       = 0,
         .tuner          = 0,
         .status         = 0,
         },{
         .index          = 5,
         .name           = "Composite 4",
         .type           = V4L2_INPUT_TYPE_CAMERA,
         .audioset       = 1,
         .tuner          = 0,
         .status         = 0,
         },{
         .index          = 6,
         .name           = "S-Video 0",
         .type           = V4L2_INPUT_TYPE_CAMERA,
         .audioset       = 1,
         .tuner          = 0,
         .status         = 0,
         },{
         .index          = 7,
         .name           = "S-Video 1",
        .type           = V4L2_INPUT_TYPE_CAMERA,
         .audioset       = 1,
         .tuner          = 0,
         .status         = 0,
         },{
         .index          = 8,
         .name           = "S-Video 2",
         .type           = V4L2_INPUT_TYPE_CAMERA,
         .audioset       = 1,
         .tuner          = 0,
         .status         = 0,
         },{
         .index          = 9,
        .name           = "S-Video 3",
         .type           = V4L2_INPUT_TYPE_CAMERA,
         .audioset       = 1,
         .tuner          = 0,
         .status         = 0,
         }
 };

int v4l2_ioctl_hook(struct cxm_softc *sc, unsigned long cmd, caddr_t arg);

#endif /* _v4l2_ioctl_hook_h */
